VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum eFileAttributes
    FILE_ATTRIBUTE_READONLY = &H1
    FILE_ATTRIBUTE_HIDDEN = &H2
    FILE_ATTRIBUTE_SYSTEM = &H4
    FILE_ATTRIBUTE_DIRECTORY = &H10
    FILE_ATTRIBUTE_ARCHIVE = &H20
    FILE_ATTRIBUTE_NORMAL = &H80
    FILE_ATTRIBUTE_TEMPORARY = &H100
    FILE_ATTRIBUTE_COMPRESSED = &H800
End Enum

Private mstrName As String
Private mstrFullPath As String
Private mlngAttributes As Long
Private mvarTimeCreated As Variant
Private mvarTimeLastAccessed As Variant
Private mvarTimeLastWritten As Variant
Private mlngSize As Long
Private mstrTypeName As String
Private mstrMajorVersion As String
Private mstrMinorVersion As String
Private mstrMajorBuild As String
Private mstrMinorBuild As String
Private WIN32_IE As Long
Private mExpItems As ExportItems

Public Property Get ExportItems() As ExportItems
    If mExpItems Is Nothing Then Set mExpItems = New ExportItems
    Set ExportItems = mExpItems
End Property

Friend Property Let IEVersion(Value As Long)
    WIN32_IE = Value
End Property

Public Property Get Name() As String
Attribute Name.VB_Description = "Returns the name of the specified file"
    Name = mstrName
End Property

Friend Property Let Name(Value As String)
    mstrName = Value
End Property

Public Property Get FullPath() As String
Attribute FullPath.VB_Description = "Returns the full path of the specified file"
    FullPath = mstrFullPath
End Property

Friend Property Let FullPath(Value As String)
On Error GoTo ErrHandler
Dim astrExportTable() As String
Dim i As Integer

    mstrFullPath = Value
    astrExportTable = Split(fEnumDLL(Value), vbNullChar)
    If UBound(astrExportTable) > 0 Then
        For i = LBound(astrExportTable) To UBound(astrExportTable)
            If Len(astrExportTable(i)) = 0 Then
                Me.ExportItems.Add "N/A", i
            Else
                Me.ExportItems.Add astrExportTable(i), i
            End If
        Next
    End If
ExitHere:
    Exit Property
ErrHandler:
    Resume ExitHere
End Property

Public Property Get Attributes() As Long
Attribute Attributes.VB_Description = "Returns the file's system attributes as a long integer"
    Attributes = mlngAttributes
End Property

Friend Property Let Attributes(Value As Long)
    mlngAttributes = Value
End Property

Public Property Get AttributesString() As String
Attribute AttributesString.VB_Description = "Returns the file's system attributes as a concatenated string"
Dim strOut As String
    If mlngAttributes And FILE_ATTRIBUTE_READONLY Then
        strOut = strOut & "R"
    End If
    If mlngAttributes And FILE_ATTRIBUTE_HIDDEN Then
        strOut = strOut & "H"
    End If
    If mlngAttributes And FILE_ATTRIBUTE_SYSTEM Then
        strOut = strOut & "S"
    End If
    If mlngAttributes And FILE_ATTRIBUTE_DIRECTORY Then
        strOut = strOut & "D"
    End If
    If mlngAttributes And FILE_ATTRIBUTE_ARCHIVE Then
        strOut = strOut & "A"
    End If
    If mlngAttributes And FILE_ATTRIBUTE_NORMAL Then
        strOut = strOut & "N"
    End If
    If mlngAttributes And FILE_ATTRIBUTE_TEMPORARY Then
        strOut = strOut & "T"
    End If
    If mlngAttributes And FILE_ATTRIBUTE_COMPRESSED Then
        strOut = strOut & "C"
    End If
    AttributesString = strOut
End Property

Public Property Get TimeCreated() As Variant
Attribute TimeCreated.VB_Description = "Returns the time when the file was created"
    TimeCreated = mvarTimeCreated
End Property

Friend Property Let TimeCreated(Value As Variant)
    mvarTimeCreated = Value
End Property

Public Property Get TimeLastAccessed() As Variant
Attribute TimeLastAccessed.VB_Description = "Returns the time when the file was last accessed"
    TimeLastAccessed = mvarTimeLastAccessed
End Property

Friend Property Let TimeLastAccessed(Value As Variant)
    mvarTimeLastAccessed = Value
End Property

Public Property Get TimeLastWritten() As Variant
Attribute TimeLastWritten.VB_Description = "Returns the time when the file was last written to"
    TimeLastWritten = mvarTimeLastWritten
End Property

Friend Property Let TimeLastWritten(Value As Variant)
    mvarTimeLastWritten = Value
End Property

Public Property Get Size() As Long
Attribute Size.VB_Description = "Returns the size of the file in bytes"
    Size = mlngSize
End Property

Friend Property Let Size(Value As Long)
    mlngSize = Value
End Property

Public Property Get TypeName() As String
Attribute TypeName.VB_Description = "Returns the file type"
    TypeName = mstrTypeName
End Property

Friend Property Let TypeName(Value As String)
    mstrTypeName = Value
End Property

Public Property Get MajorVersion() As String
Attribute MajorVersion.VB_Description = "Returns the major version number of a dll/ocx/exe"
    MajorVersion = mstrMajorVersion
End Property

Friend Property Let MajorVersion(Value As String)
    mstrMajorVersion = Value
End Property

Public Property Get MinorVersion() As String
Attribute MinorVersion.VB_Description = "Returns the minor version number of a dll/ocx/exe"
    MinorVersion = mstrMinorVersion
End Property

Friend Property Let MinorVersion(Value As String)
    mstrMinorVersion = Value
End Property

Public Property Get MajorBuild() As String
Attribute MajorBuild.VB_Description = "Returns the major build number of a dll/ocx/exe"
    MajorBuild = mstrMajorBuild
End Property

Friend Property Let MajorBuild(Value As String)
    mstrMajorBuild = Value
End Property

Public Property Get MinorBuild() As String
Attribute MinorBuild.VB_Description = "Returns the minor build number of a dll/ocx/exe"
    MinorBuild = mstrMinorBuild
End Property

Friend Property Let MinorBuild(Value As String)
    mstrMinorBuild = Value
End Property


Public Property Get CompactPath(ByVal MaxCharacters As Integer) As String
Attribute CompactPath.VB_Description = "Trims the value of FullPath so that it's maximum width is MaxCharacters.  The trimmed space is replaced by dots. If the system does not support this property, the property returns a zero length string"
On Error GoTo ErrHandler

    If WIN32_IE > 4& Then
        CompactPath = fCompactPath(Me.FullPath, MaxCharacters)
    End If

ExitHere:
    Exit Property
ErrHandler:
    CompactPath = vbNullString
    With Err
        .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume ExitHere
End Property

Private Sub Class_Terminate()
    Set mExpItems = Nothing
End Sub
