VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Files"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Collection" ,"File"
Attribute VB_Ext_KEY = "Member0" ,"File"
Option Explicit

'   Local collection to hold File objects
Private mcolFiles As Collection
Private Const MAX_PATH = 260

'  The FILETIME data structure is a 64-bit value representing the number
'  of 100-nanosecond intervals since January 1, 1601. It is the
'  means by which Win32 determines the date and time.
Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type
 
'  represents a date and time using individual members for the month,
'  day, year, weekday, hour, minute, second, and millisecond.
Private Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type
 
Private Type TIME_ZONE_INFORMATION
  Bias As Long
  StandardName(0 To 63) As Byte
  StandardDate As SYSTEMTIME
  StandardBias As Long
  DaylightName(0 To 63) As Byte
  DaylightDate As SYSTEMTIME
  DaylightBias As Long
End Type

'   structure contains information retrieved by the GetFileInformationByHandle function
Private Type BY_HANDLE_FILE_INFORMATION
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    dwVolumeSerialNumber As Long
    nFileSizeHigh As Long
    nFileSizeLow As Long
    nNumberOfLinks As Long
    nFileIndexHigh As Long
    nFileIndexLow As Long
End Type
 
'   structure describes a file found by the FindFirstFile, FindFirstFileEx,
'   or FindNextFile function
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

'   Contains information about a file object.
Private Type SHFILEINFO
    hIcon As Long                           '  out: icon
    iIcon As Long                            '  out: icon index
    dwAttributes As Long               '  out: SFGAO_ flags
    szDisplayName As String * MAX_PATH '  out: display name (or path)
    szTypeName As String * 80      '  out: type name
End Type

'   structure contains version information about a file. This
'   information is language and code page independent.
Private Type VS_FIXEDFILEINFO
    dwSignature As Long              '   Contains the value 0xFEEFO4BD (szKey)
    dwStrucVersion As Long         '  Specifies the binary version number of this structure.
    dwFileVersionMS As Long       '  most significant 32 bits of the file's binary version number.
    dwFileVersionLS As Long        '   least significant 32 bits of the file's binary version number.
    dwProductVersionMS As Long '  most significant 32 bits of the binary version number of the product with which this file was distributed
    dwProductVersionLS As Long  '  least significant 32 bits of the binary version number of the product with which this file was distributed
    dwFileFlagsMask As Long        '  Contains a bitmask that specifies the valid bits in dwFileFlags.
    dwFileFlags As Long                '  Contains a bitmask that specifies the Boolean attributes of the file.
    dwFileOS As Long                    '  operating system for which this file was designed.
    dwFileType As Long                 '  general type of file.
    dwFileSubtype As Long           '  function of the file.
    dwFileDateMS As Long            '  most significant 32 bits of the file's 64-bit binary creation date and time stamp.
    dwFileDateLS As Long             '  least significant 32 bits of the file's 64-bit binary creation date and time stamp.
End Type

' formats time as a time string for a specified locale.
' The function '  formats either a specified time or the local system time.
Private Declare Function apiGetTimeFormat Lib "kernel32" _
    Alias "GetTimeFormatA" _
    (ByVal Locale As Long, _
    ByVal dwFlags As Long, _
    lpTime As SYSTEMTIME, _
    ByVal lpFormat As Long, _
    ByVal lpTimeStr As String, _
    ByVal cchTime As Long) _
    As Long
 
'  formats a date as a date string for a specified locale. The
'  function formats either a specified date or the local system date.
Private Declare Function apiGetDateFormat Lib "kernel32" _
    Alias "GetDateFormatA" _
    (ByVal Locale As Long, _
    ByVal dwFlags As Long, _
    lpDate As SYSTEMTIME, _
    ByVal lpFormat As Long, _
    ByVal lpDateStr As String, _
    ByVal cchDate As Long) _
    As Long
 
'  retrieves the current time-zone parameters. These parameters control
'  the translations between Coordinated Universal Time (UTC) and local time.
Private Declare Function apiGetTimeZoneInformation Lib "kernel32" _
    Alias "GetTimeZoneInformation" _
    (lpTimeZoneInformation As TIME_ZONE_INFORMATION) _
    As Long

'   converts a 64-bit file time to system time format.
Private Declare Function apiFileTimeToSystemTime Lib "kernel32" _
    Alias "FileTimeToSystemTime" _
    (lpFileTime As FILETIME, _
    lpSystemTime As SYSTEMTIME) _
    As Long

'   moves memory either forward or backward, aligned or unaligned,
'   in 4-byte blocks, followed by any remaining bytes.
Private Declare Sub sapiCopyMem Lib "kernel32" _
    Alias "RtlMoveMemory" _
    (Destination As Any, _
    Source As Any, _
    ByVal Length As Long)

'   Retrieves information about an object in the file system, such as a file,
'   a folder, a directory, or a drive root.
Private Declare Function apiSHGetFileInfo Lib "shell32.dll" _
    Alias "SHGetFileInfoA" _
    (ByVal pszPath As String, _
    ByVal dwFileAttributes As Long, _
    psfi As SHFILEINFO, _
    ByVal cbFileInfo As Long, _
    ByVal uFlags As Long) _
    As Long
    
'  Returns size of version info in Bytes
Private Declare Function apiGetFileVersionInfoSize Lib "version.dll" _
    Alias "GetFileVersionInfoSizeA" _
    (ByVal lptstrFilename As String, _
    lpdwHandle As Long) _
    As Long

'  Read version info into buffer
' /* Length of buffer for info *
' /* Information from GetFileVersionSize *
' /* Filename of version stamped file *
Private Declare Function apiGetFileVersionInfo Lib "version.dll" _
    Alias "GetFileVersionInfoA" _
    (ByVal lptstrFilename As String, _
    ByVal dwHandle As Long, _
    ByVal dwLen As Long, _
    lpData As Any) _
    As Long
    
'   returns selected version information from the specified version-information resource.
Private Declare Function apiVerQueryValue Lib "version.dll" _
    Alias "VerQueryValueA" _
    (pBlock As Any, _
    ByVal lpSubBlock As String, _
    lplpBuffer As Long, _
    puLen As Long) _
    As Long
    
'creates or opens the following objects and returns a handle that can be used to access the object
Private Declare Function apiCreateFile Lib "kernel32" _
    Alias "CreateFileA" _
    (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) _
    As Long
    
'retrieves information about a specified file
Private Declare Function apiGetFileInformationByHandle Lib "kernel32" _
    Alias "GetFileInformationByHandle" _
    (ByVal hFile As Long, _
    lpFileInformation As BY_HANDLE_FILE_INFORMATION) _
    As Long
    
'closes an open object handle.
Private Declare Function apiCloseHandle Lib "kernel32" _
    Alias "CloseHandle" _
    (ByVal hObject As Long) _
    As Long
    
'  do not use user overrides
Private Const LOCALE_NOUSEROVERRIDE = &H80000000
'  use the system ACP
Private Const LOCALE_USE_CP_ACP = &H40000000
 
' Time Flags for GetTimeFormatW.
'  do not use minutes or seconds
Private Const TIME_NOMINUTESORSECONDS = &H1
'  do not use seconds
Private Const TIME_NOSECONDS = &H2
'  do not use time marker
Private Const TIME_NOTIMEMARKER = &H4
'  always use 24 hour format
Private Const TIME_FORCE24HOURFORMAT = &H8
 
'  Date Flags for GetDateFormat.
'  use short date picture
Private Const DATE_SHORTDATE = &H1
'  use long date picture
Private Const DATE_LONGDATE = &H2
'  use alternate calendar (if any)
Private Const DATE_USE_ALT_CALENDAR = &H4
 
'#if(WINVER >= 0x0500)
'  use year month picture
Private Const DATE_YEARMONTH = &H8
'  add marks for left to right reading order layout
Private Const DATE_LTRREADING = &H10
'  add marks for right to left reading order layout
Private Const DATE_RTLREADING = &H20
'#endif /* WINVER >= 0x0500 */
 
Private Const LOCALE_SYSTEM_DEFAULT = &H800
Private Const LOCALE_USER_DEFAULT = &H400
 
Private Const TIME_ZONE_ID_INVALID = &HFFFFFFFF
Private Const TIME_ZONE_ID_UNKNOWN = 0
Private Const TIME_ZONE_ID_STANDARD = 1
Private Const TIME_ZONE_ID_DAYLIGHT = 2
    
Private Const MAXDWORD = &HFFFFFFFF
Private Const SHGFI_TYPENAME = &H400   '  Retrieve the string that describes the file's type.
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const INVALID_HANDLE_VALUE = -1
Private Const OPEN_EXISTING = 3

Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2

Private WIN32_IE As Long

Friend Property Get IEVersion() As Long
    IEVersion = WIN32_IE
End Property

Friend Function Add(ByVal WFDPtr As Long, Path As String) As File
'   Not viewable externally, Friend procedure
'   used by FileObject class to add files returned by FindFirst/NextFile
'
On Error GoTo ErrHandler
Dim lpData As WIN32_FIND_DATA
Dim clsFile As File

    Set clsFile = New File

    '   Fill the local UDT with the struct info present at pointer WFDPtr
    Call sapiCopyMem(lpData, ByVal WFDPtr, Len(lpData))

    With clsFile
        '   Remove the trailing vbNullChars from the filename
        .Name = fStripNull(StrConv(lpData.cFileName, vbFromUnicode))
        .FullPath = Path & .Name
        '   These attributes can ANDed with the Public enums to return individual attributes.
        .Attributes = lpData.dwFileAttributes
        '   Time the file was created
        .TimeCreated = fGetFileTime(VarPtr(lpData), 1, 1)
        '   Time the file was last accessed
        .TimeLastAccessed = fGetFileTime(VarPtr(lpData), 2, 1)
        '   Time the file was last written to
        .TimeLastWritten = fGetFileTime(VarPtr(lpData), 3, 1)
        '   The size of the file
        .Size = ((lpData.nFileSizeHigh * (MAXDWORD + 1)) + lpData.nFileSizeLow)
        '   The description associated with the file
        .TypeName = fGetFileDesc(.FullPath)
        '   File version info (Major/Minor builds)
        Call sGetFileVersion(clsFile)
        
        .IEVersion = WIN32_IE
    End With
    
    '   Add the file to the local collection
    mcolFiles.Add clsFile, clsFile.FullPath
    
    '   Return the new instance back
    Set Add = clsFile
ExitHere:
    Set clsFile = Nothing
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume ExitHere
End Function

Public Property Get Item(Index As Variant) As File
Attribute Item.VB_Description = "Default member, returns a File object."
Attribute Item.VB_UserMemId = 0
  Set Item = mcolFiles(Index)
End Property

Public Property Get Count() As Long
Attribute Count.VB_Description = "Returns the number of files found in the search."
    Count = mcolFiles.Count
End Property

Public Function GetInfoForFile(ByVal FileName As String) As File
Attribute GetInfoForFile.VB_Description = "Allows you to bypass the search operation and get reference to a File object that corressponds to the filename passed to this property."
'   This function can be used to get to the Details info of File Class
'   without performing a search for the file.
'   This proc is the reason why this class is MultiUse.
'
On Error GoTo ErrHandler
Dim lpFileInfo As BY_HANDLE_FILE_INFORMATION
Dim hFile As Long, lngRet As Long, clsFile As File

    '   Get a handle to the file
    hFile = apiCreateFile(FileName, _
                        GENERIC_READ, FILE_SHARE_READ, 0, _
                        OPEN_EXISTING, 0, 0)
    If Not hFile = INVALID_HANDLE_VALUE Then
        lngRet = apiGetFileInformationByHandle(hFile, lpFileInfo)
        If Not lngRet = 0 Then
            '   If the file info was successfully retrieved,
            '   then instantiate a new File object and fill it with info.
            Set clsFile = New File
            With clsFile
                .FullPath = FileName
                .Name = Dir(FileName, vbHidden Or vbSystem)
                .Attributes = lpFileInfo.dwFileAttributes
                .TimeCreated = fGetFileTime(VarPtr(lpFileInfo), 1, 2)
                .TimeLastAccessed = fGetFileTime(VarPtr(lpFileInfo), 2, 2)
                .TimeLastWritten = fGetFileTime(VarPtr(lpFileInfo), 3, 2)
                .Size = ((lpFileInfo.nFileSizeHigh * (MAXDWORD + 1)) + lpFileInfo.nFileSizeLow)
                .TypeName = fGetFileDesc(.FullPath)
                Call sGetFileVersion(clsFile)
                .IEVersion = WIN32_IE
            End With
        End If
    End If
    '   Return the file back
    Set GetInfoForFile = clsFile
ExitHere:
    Set clsFile = Nothing
    Call apiCloseHandle(hFile)
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume ExitHere
End Function

Friend Sub Remove(Index As Variant)
'   Clients cannot remove items, it's here just for convenience
'
On Error GoTo ErrHandler
    mcolFiles.Remove Index
ExitHere:
    Exit Sub
ErrHandler:
    With Err
        .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume ExitHere
End Sub

Private Function fGetFileTime(lpFileData As Long, intTimeType As Integer, intCallType As Integer) As Variant
'   Returns a particular FileTime associated with a file.
'strFileName:    Full path to the file
'intTimeType:    = 1 to retrieve Creation Time
'                      =  2 To retrieve Last Access Time
'                      = 3 to retrieve LastWrite Time
'  intCallType=1 => Use Win32_Find_Data
'  intCallType=2 => Use BY_HANDLE_FILE_INFORMATION
'
On Error GoTo ErrHandler
Dim lngRet As Long
Dim lpSystem As SYSTEMTIME
Dim lpFileWFD As WIN32_FIND_DATA
Dim lpFileBHFI As BY_HANDLE_FILE_INFORMATION
Dim strTime As String, strDate As String
Dim lngLen As Long
Const conERR_GENERIC = vbObjectError + 10000

    '   fill the correct UDT based on which proc is calling this function
    Select Case intCallType
        Case 1:
            Call sapiCopyMem(lpFileWFD, ByVal lpFileData, Len(lpFileWFD))
        Case 2:
            Call sapiCopyMem(lpFileBHFI, ByVal lpFileData, Len(lpFileBHFI))
        Case Else:
            Err.Raise conERR_GENERIC
    End Select
 
    '   Retrieve the various time values
    Select Case intTimeType
        Case 1:    'Creation Time
            If intCallType = 1 Then
                lngRet = apiFileTimeToSystemTime(lpFileWFD.ftCreationTime, lpSystem)
            Else
                lngRet = apiFileTimeToSystemTime(lpFileBHFI.ftCreationTime, lpSystem)
            End If
        Case 2:    'LastAccess Time
            If intCallType = 1 Then
                lngRet = apiFileTimeToSystemTime(lpFileWFD.ftLastAccessTime, lpSystem)
            Else
                lngRet = apiFileTimeToSystemTime(lpFileBHFI.ftLastAccessTime, lpSystem)
            End If
        Case 3:    'LastWrite time
            If intCallType = 1 Then
                lngRet = apiFileTimeToSystemTime(lpFileWFD.ftLastWriteTime, lpSystem)
            Else
                lngRet = apiFileTimeToSystemTime(lpFileBHFI.ftLastWriteTime, lpSystem)
            End If
        Case Else:  'invalid value
            
    End Select
 
    '  format the time according the system settings
    strTime = Space$(255)
    lngLen = apiGetTimeFormat(LOCALE_SYSTEM_DEFAULT, _
                                    LOCALE_NOUSEROVERRIDE, _
                                    lpSystem, _
                                    0, _
                                    strTime, _
                                    Len(strTime) - 1)
    strTime = Left$(strTime, lngLen - 1)
 
    '  format the date according to the system settings
    strDate = Space$(255)
    lngLen = apiGetDateFormat(LOCALE_SYSTEM_DEFAULT, _
                                    LOCALE_NOUSEROVERRIDE, _
                                    lpSystem, _
                                    0, _
                                    strDate, _
                                    Len(strDate) - 1)
    strDate = Left$(strDate, lngLen - 1)
 
    fGetFileTime = strDate & Chr$(vbKeySpace) & strTime
 
    '  UTC = local time + bias
    fGetFileTime = CStr(DateAdd("n", -fGetTimeBias(), CDate(fGetFileTime)))
ExitHere:
  Exit Function
ErrHandler:
  fGetFileTime = Null
  Resume ExitHere
End Function

Private Function fGetTimeBias() As Long
'  Returns Local-UTC Bias in minutes
Dim lpTZI As TIME_ZONE_INFORMATION
Dim lngRet As Long, lngOut As Long
   lngRet = apiGetTimeZoneInformation(lpTZI)
    Select Case lngRet
        Case TIME_ZONE_ID_INVALID:
            'Error
            lngOut = 0
        Case TIME_ZONE_ID_UNKNOWN:
            'cannot determine
            lngOut = 0
        Case TIME_ZONE_ID_STANDARD:
            lngOut = lpTZI.Bias + lpTZI.StandardBias
        Case TIME_ZONE_ID_DAYLIGHT:
            lngOut = lpTZI.Bias + lpTZI.DaylightBias
    End Select
    fGetTimeBias = lngOut
End Function

Private Function fGetFileDesc(ByVal strFilename As String) As String
'   returns the description (Application/Microsoft Access database etc.)
'   for the specified file, strFileName
'
On Error GoTo ErrHandler
Dim psfi As SHFILEINFO

    If apiSHGetFileInfo(strFilename, 0, _
                psfi, Len(psfi), _
                SHGFI_TYPENAME) > 0 Then
        fGetFileDesc = fStripNull(psfi.szTypeName)
    End If
     
ExitHere:
    Exit Function
ErrHandler:
    fGetFileDesc = vbNullString
    Resume ExitHere
End Function

Private Sub sGetFileVersion(clsFile As File)
'   For executable files (Applications),
'   return it's version
'
On Error GoTo ErrHandler
Dim lngSize As Long
Dim lngRet As Long
Dim pBlock() As Byte
Dim lpfi As VS_FIXEDFILEINFO
Dim lppBlock As Long

    '   GetFileVersionInfo requires us to get the size
    '   of the file version information first, this info is in the format
    '   of VS_FIXEDFILEINFO struct
    lngSize = apiGetFileVersionInfoSize(clsFile.FullPath, lngRet)

    '   If the OS can obtain version info, then proceed on
    If Not lngSize = 0 Then
        '   the info in pBlock is always in Unicode format
        ReDim pBlock(lngSize)
        lngRet = apiGetFileVersionInfo(clsFile.FullPath, 0, _
                    lngSize, pBlock(0))
        If Not lngRet = 0 Then
            '   the same pointer to pBlock can be passed to VerQueryValue
            lngRet = apiVerQueryValue(pBlock(0), _
                                "\", lppBlock, lngSize)
            
            '   fill the VS_FIXEDFILEINFO struct with bytes from pBlock
            '   VerQueryValue fills lngSize with the length of the block.
            Call sapiCopyMem(lpfi, ByVal lppBlock, lngSize)
            With clsFile
                '   build the version info strings
                .MajorBuild = CStr(HIWord(lpfi.dwFileVersionLS))
                .MinorBuild = CStr(LOWord(lpfi.dwFileVersionLS))
                .MajorVersion = CStr(HIWord(lpfi.dwFileVersionMS))
                .MinorVersion = CStr(LOWord(lpfi.dwFileVersionMS))
            End With
        End If
    End If

ExitHere:
    Erase pBlock
    Exit Sub
ErrHandler:
    Resume ExitHere
End Sub

Private Function LOWord(dw As Long) As Integer
'    retrieves the low-order word from the given 32-bit value.
    If dw And &H8000& Then
        LOWord = dw Or &HFFFF0000
    Else
        LOWord = dw And &HFFFF&
    End If
End Function

Private Function HIWord(dw As Long) As Integer
'    retrieves the high-order word from the given 32-bit value.
  HIWord = (dw And &HFFFF0000) \ &H10000
End Function

Private Function fStripNull(str As String) As String
'   Trims the string at the first occurrence of vbNullChar
'
Static intPos As Integer
    intPos = 0
    intPos = InStr(str, vbNullChar)
    If intPos > 0 Then
        fStripNull = Left$(str, intPos - 1)
    End If
End Function

Public Function Enumerate() As IUnknown
Attribute Enumerate.VB_UserMemId = -4
Attribute Enumerate.VB_MemberFlags = "40"
    Set Enumerate = mcolFiles.[_NewEnum]
End Function

Private Sub Class_Initialize()
On Error GoTo ErrHandler
Dim clsFile As File
Dim strMS As String
Dim strLS As String

    Set mcolFiles = New Collection
    Set clsFile = New File
    
    Call sGetFileVersion(clsFile)
    Select Case clsFile.MajorVersion
        Case "4.70"
            WIN32_IE = 3&
        Case "4.71", "4.72"
            WIN32_IE = 4&
        Case "5.0"
            WIN32_IE = 5&
    End Select
    
ExitHere:
    Set clsFile = Nothing
    Exit Sub
ErrHandler:
    Resume ExitHere
End Sub

Private Sub Class_Terminate()
    Set mcolFiles = Nothing
End Sub

