Attribute VB_Name = "modMain"
Option Explicit
Option Private Module

Private Type IMAGE_DEBUG_INFORMATION
    List As Long
    Size As Long
    MappedBase As Long
    Machine As Long
    Characteristics As Long
    CheckSum As Long
    ImageBase As Long
    SizeOfImage As Long
    NumberOfSections As Long
    Sections As Long
    ExportedNamesSize As Long
    ExportedNames As Long
    NumberOfFunctionTableEntries As Long
    FunctionTableEntries As Long
    LowestFunctionStartingAddress As Long
    HighestFunctionEndingAddress As Long
    NumberOfFpoTableEntries As Long
    FpoTableEntries As Long
    SizeOfCoffSymbols As Long
    CoffSymbols As Long
    SizeOfCodeViewSymbols As Long
    CodeViewSymbols As Long
    ImageFilePath As Long
    ImageFileName As Long
    DebugFilePath As Long
    TimeDateStamp As Long
    RomImage As Long
    DebugDirectory As Long
    NumberOfDebugDirectories As Long
    OriginalFunctionTableBaseAddress As Long
    Reserved0 As Long
    Reserved1 As Long
    Reserved2 As Long
End Type

Private Declare Function apiMapDebugInformation _
    Lib "ImageHlp.dll" Alias "MapDebugInformation" _
    (ByVal FileHandle As Long, _
    ByVal FileName As String, _
    ByVal SymbolPath As String, _
    ByVal ImageBase As Long) _
    As Long
    
Private Declare Function apiUnmapDebugInformation _
    Lib "ImageHlp.dll" Alias "UnmapDebugInformation" _
    (ByVal DebugInfo As Long) _
    As Long
    
Private Declare Function apiCreateFile Lib "kernel32" _
    Alias "CreateFileA" _
    (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) _
    As Long

Private Declare Function apiCloseHandle Lib "kernel32" _
    Alias "CloseHandle" _
    (ByVal hObject As Long) _
    As Long
    
Private Declare Sub sapiCopyMem _
    Lib "kernel32" Alias "RtlMoveMemory" _
    (Destination As Any, _
    Source As Any, _
    ByVal Length As Long)


Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const INVALID_HANDLE_VALUE = -1
Private Const OPEN_EXISTING = 3
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const MAX_PATH = 260


'  Windows NT/2000: Requires Windows 2000
'        (or Windows NT 4.0 with Internet Explorer 4.0 or later)..
'
'  Windows 95/98: Requires Windows 98 _
'       (or Windows 95 with Internet Explorer 4.0 or later)..
'
Private Declare Function apiPathCompactPathEx Lib "shlwapi.dll" _
    Alias "PathCompactPathExA" _
    (ByVal pszOut As String, _
    ByVal pszSrc As String, _
    ByVal cchMax As Integer, _
    ByVal dwFlags As Long) _
    As Integer

Function fEnumDLL(strDLLName As String) As String
' ?fEnumDLL("C:\Winnt\System32\WININET.DLL")
'
On Error GoTo ErrHandler
Dim hMod As Long
Dim pDBG As Long
Dim tDbg As IMAGE_DEBUG_INFORMATION
Dim strOut As String
Dim lngLen As Long
Dim i As Long
Const ERR_GENERIC = vbObjectError + 5555

    hMod = apiCreateFile(strDLLName, GENERIC_READ, _
                        FILE_SHARE_READ Or FILE_SHARE_WRITE, _
                        0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)

    If hMod = INVALID_HANDLE_VALUE Then
        Err.Raise ERR_GENERIC
    End If
    
    pDBG = apiMapDebugInformation(hMod, strDLLName, vbNullString, 0)
    If pDBG = 0 Then Err.Raise ERR_GENERIC

    Call sapiCopyMem(tDbg, ByVal pDBG, Len(tDbg))

    With tDbg
        strOut = String$(.ExportedNamesSize, vbNullChar)
        Call sapiCopyMem(ByVal strOut, ByVal .ExportedNames, .ExportedNamesSize)
    End With
    fEnumDLL = strOut
ExitHere:
    Call apiUnmapDebugInformation(pDBG)
    Call apiCloseHandle(hMod)
    Exit Function
ErrHandler:
    fEnumDLL = vbNullString
    Resume ExitHere
End Function


Public Function fCompactPath(ByVal strFilename As String, _
                                            ByVal cchMax As Integer) As String
Dim strOut As String
Dim lpOut As Long

    strOut = Space$(cchMax + 1)
    If Not (apiPathCompactPathEx(strOut, _
                strFilename, cchMax + 1, 0) = 0) Then
        fCompactPath = Left$(strOut, cchMax)
    End If

End Function


